<%@ Page Language="C#" AutoEventWireup="true" CodeFile="Drop_To_TextArea.aspx.cs"
    Inherits="Drop_To_TextArea" %>

<%@ Register Assembly="Telerik.Web.UI" Namespace="Telerik.Web.UI" TagPrefix="telerik" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Untitled Page</title>
</head>
<body>
    <form id="myForm" runat="server">
    <div>

        <script type="text/javascript">
            function OnClientNodeDroppingHandler(sender, eventArgs) {
                var target = eventArgs.get_htmlElement();
                var textToInsert = eventArgs.get_sourceNode().get_text();
                if (target.tagName == "TEXTAREA") {
                    insertAtCaret(target, textToInsert);
                }

                eventArgs.set_cancel(true);
            }


            function setCaret(textEl) {
                if (textEl.createTextRange) {
                    textEl.caretPos = document.selection.createRange().duplicate();
                }
            }


            function insertAtCaret(obj, string) {
                if (typeof (document.selection) != 'undefined') {
                    if (obj.createTextRange && obj.caretPos) {

                        var caretPos = obj.caretPos;
                        caretPos.text =
            caretPos.text.charAt(caretPos.text.length - 1) == ' ' ?
             string + ' ' : string;
                    }
                    else {
                        obj.value = string;
                    }
                }
                else
                    if (typeof (obj.selectionStart) != 'undefined') {
                    var start = obj.selectionStart;

                    obj.value = obj.value.substr(0, start)
            + string
            + obj.value.substr(obj.selectionEnd, obj.value.length);

                    start += string.length;
                    obj.setSelectionRange(start, start);
                }
                else
                    obj.value += string;

                obj.focus();
            }

        </script>

        <asp:ScriptManager ID="ScriptManager1" runat="server">
        </asp:ScriptManager>
        <telerik:RadTreeView ID="RadTreeView1" EnableDragAndDrop="True" OnClientNodeDropping="OnClientNodeDroppingHandler"
            runat="server" Skin="Hay">
            <Nodes>
                <telerik:RadTreeNode runat="server" Text="Root RadTreeNode1">
                    <Nodes>
                        <telerik:RadTreeNode runat="server" Text="Child RadTreeNode 1">
                        </telerik:RadTreeNode>
                        <telerik:RadTreeNode runat="server" Text="Child RadTreeNode 2">
                        </telerik:RadTreeNode>
                    </Nodes>
                </telerik:RadTreeNode>
                <telerik:RadTreeNode runat="server" Text="Root RadTreeNode2">
                    <Nodes>
                        <telerik:RadTreeNode runat="server" Text="Child RadTreeNode 1">
                        </telerik:RadTreeNode>
                    </Nodes>
                </telerik:RadTreeNode>
                <telerik:RadTreeNode runat="server" Text="Root RadTreeNode3">
                </telerik:RadTreeNode>
            </Nodes>
        </telerik:RadTreeView>
        <textarea name="myTextArea" rows="20" cols="50" onselect="setCaret(this);" onclick="setCaret(this);"
            onkeyup="setCaret(this);">
</textarea>
    </div>
    </form>
</body>
</html>
